(define-module (ui zabbix-agent ajax)
  :use-module (alterator ajax)
  :use-module (alterator woo)
  :export (init))

(define (load-values)
  (catch/message
    (lambda ()
      (form-update-value-list '("enable_service"
                                "enable_exec"
                                "listen_ip"
                                "server_ip"
                                "custom_hostname"
                                "hostname")
                              (woo-read-first "/zabbix-agent")))))

(define (refresh-hostname)
  (let ((status (form-value "custom_hostname")))
    (form-update-activity "hostname_label" status)
    (form-update-activity "hostname" status)
    (not status)))

(define (refresh)
  (refresh-hostname))

(define (send-values)
  (catch/message
    (lambda ()
      (apply woo-write "/zabbix-agent" (form-value-list '("enable_service"
                                                          "enable_exec"
                                                          "listen_ip"
                                                          "server_ip"
                                                          "custom_hostname"
                                                          "hostname"))))))

(define (init)
  (form-bind "apply" "click" send-values)
  (form-bind "reset" "click" init)
  (form-bind "custom_hostname" "change"
    (lambda () (refresh-hostname)))
  (load-values)
  (refresh))
